#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#define  WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <winsock.h>
#include "ping.h"


pfnHV pIcmpCreateFile;
pfnBH pIcmpCloseHandle;
pfnDHDPWPipPDD pIcmpSendEcho;

class CMinMax 
{
public:
	int min;
	int max;

public:
	CMinMax()
	{
		min=0;
		max=0;
	}
	void Set(int tmin,int tmax=-1)
	{
		min = tmin;
		if (tmax==-1) tmax = tmin;
		max = tmax;
	}
	void Set(char *text)
	{
		int l=strlen(text);
		char *maxValue = NULL;
		for (int i=0;i<l;i++) if (text[i]=='-') { maxValue=text+i+1; break; }
		if (maxValue) maxValue[-1]='\0';
		min = atoi(text);
		if (maxValue) max = atoi(maxValue);
		else max = min;
	}
};

main(int argc, char *argv[])
{
    DWORD        dwIP ;
    WSADATA      wsaData;


	CMinMax ports[100];
	int nbPort=0;


	HINSTANCE hIcmp = LoadLibrary("ICMP.DLL");

	pIcmpCreateFile = (pfnHV)GetProcAddress(hIcmp,"IcmpCreateFile");
	pIcmpCloseHandle = (pfnBH)GetProcAddress(hIcmp,"IcmpCloseHandle");
	pIcmpSendEcho = (pfnDHDPWPipPDD)GetProcAddress(hIcmp,"IcmpSendEcho");

	if ( !pIcmpCreateFile || !pIcmpCloseHandle || !pIcmpSendEcho) 
	{
		printf("Pb d'acces a la dll \"icmp.dll\"\n");
        return 0;
	}

    if (argc < 2) 
	{
		printf("*********************************************************************\n");
		printf("* Ping - write by alkaine - sebbloc@ifrance.com - www.mignonsoft.com *\n");
		printf("*********************************************************************\n");
		printf("Usage: <ip-address> [port[-portEnd]] \n"
			   "ex.: ping www.yahoo.fr  (default port is HTTP 80 port)\n"\
			   "ex.: ping www.google.fr 21\n"\
			   "ex.: ping 192.168.10.40 10-22"\
			   "ex.: ping www.microsoft.com 1-80 4000-5000");
        return 0;
    }
	if (argc==2) 
	{
		ports[0].Set(80);
		nbPort++;
	}
	else
	{
		for (int i=2;i<argc;i++)
		{
			ports[i-2].Set(argv[i]);
			nbPort++;
		}
	}
	
    WSAStartup(0x0101, &wsaData);

    // Resolve machine name or translate address
    if ((dwIP = stoip(argv[1])) == 0) 
	{
        printf("Error: address %s unknown\n", argv[1]);
        WSACleanup();
        return 0;
    }

	for (int i=0;i<nbPort;i++)
	{
		for (int j=ports[i].min;j<=ports[i].max;j++)
			CheckPort(dwIP, (USHORT)j, TIME_OUT_TEST_PORT);
	}
    WSACleanup();

    return 0;
}

//------------------------------------------------------------------

int CheckPort(DWORD dwIP, USHORT usPort, ULONG timeout)
{
    // Check if the IP port is listening on the given machine
    SOCKET s;
    struct timeval      Time = { 1, 0 };
    struct sockaddr_in  SrvAddr, CliAddr;

	printf("Port %d ... ",usPort);
	fflush(stdout);

    if ((s = socket(PF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET) {
        printf("Error: unable to create socket\n");
        return 0;
    }

    // Bind the socket
    CliAddr.sin_family      = AF_INET;
    CliAddr.sin_addr.s_addr = INADDR_ANY;
    CliAddr.sin_port        = 0;
    bind(s, (PSOCKADDR)&CliAddr, sizeof(CliAddr));

    // Connect
    SrvAddr.sin_family      = AF_INET;
    SrvAddr.sin_addr.s_addr = dwIP;
    SrvAddr.sin_port        = htons(usPort);
    if (connectex(s, (LPSOCKADDR)&SrvAddr, sizeof(SrvAddr) , timeout) == SOCKET_ERROR) 
	{
		printf("not listening\n");

        closesocketex(s, TRUE);
        return 0;
    }
    // Connect succeeded, so the port is listening
    printf("is listening\n");
    closesocket(s);

    return 1;
}

//------------------------------------------------------------------

int connectex(SOCKET s, const struct sockaddr *name,int namelen, long timeout)
{
    // As connect() but with timeout setting.
    int            rc = 0;
    ULONG          ulB;
    struct timeval Time;
    fd_set         FdSet;

    ulB = TRUE; // Set socket to non-blocking mode
    ioctlsocket(s, FIONBIO, &ulB);

    if (connect(s, name, sizeof(SOCKADDR)) == SOCKET_ERROR) 
	{
        if (WSAGetLastError() == WSAEWOULDBLOCK) 
		{
            // now wait for the specified time
            FD_ZERO(&FdSet);
            FD_SET(s, &FdSet);

            Time.tv_sec  = timeout / 1000L;
            Time.tv_usec = (timeout % 1000) * 1000;
            rc = select(0, NULL, &FdSet, NULL, &Time);

        }
    }

    ulB = FALSE; // Restore socket to blocking mode
    ioctlsocket(s, FIONBIO, &ulB);

    return (rc > 0) ? 0 : SOCKET_ERROR;
}

//------------------------------------------------------------------

int closesocketex(SOCKET sock, BOOL reset)
{
    // Close socket. If reset is true we do a hard close.
    int    rc;
    LINGER linger;

    if (sock == INVALID_SOCKET)
        return 0;

    if (reset == TRUE) {
        // Enable linger with a zero timeout
        linger.l_onoff  = TRUE;
        linger.l_linger = 0;
        setsockopt(sock, SOL_SOCKET, SO_LINGER,
                    (char FAR *)&linger, sizeof(linger));
    }
    rc = closesocket(sock);

    return rc;
}

//------------------------------------------------------------------

DWORD stoip(char *lpIP)
{
    // String to IP: optionally resolve a host name and convert
    // an ASCII IP dot address to its binary network form.
    int   i, bDot = TRUE;
    char  szBuffer[64];
    DWORD dwIP = 0L;

    if ((lpIP[0] != '\0') && (isdigit(lpIP[0]) == FALSE)) {
        // Name is specified, lookup ip address
        struct hostent *pHost;

        if ((pHost = gethostbyname((LPSTR)lpIP)) != NULL) {
            memcpy((char *)&dwIP, pHost->h_addr_list[0], 4);
        }
    }
    else 
	{
        // Address specified. Remove all preceding zeros first,
        // inet_adr will interpret it as an octal number.
        i = 0;
        while (*lpIP) {

            while ((*(lpIP) == '0') && (isdigit(*(lpIP + 1)))
                                            && (bDot == TRUE)) {
                lpIP++;
            }
            bDot = (*lpIP == '.');
            szBuffer[i++] = *lpIP++;
        }
        szBuffer[i] = '\0';
        dwIP = inet_addr(szBuffer);
    }
    return dwIP;
}






